﻿local L
local locale = GetLocale()
if locale == "esES" then
	L = {
--		["Flight"] = "Flight",
--		["Automatically dismount or unshapeshift when speaking to flight masters"] = "Automatically dismount or unshapeshift when speaking to flight masters",
		["Ghost Wolf"] = "Lobo fantasmal",
		["Shadowform"] = "Forma de las Sombras",
	}
elseif locale == "frFR" then
	L = {
		["Ghost Wolf"] = "Loup fantôme",
		["Shadowform"] = "Forme d'Ombre",
	}
elseif locale == "koKR" then
	L = {
		["Automatically dismount or unshapeshift when speaking to flight masters"] = "비행 조련사와 대화시 탈것에서 내리거나 변신 상태를 해제합니다.",
		["Ghost Wolf"] = "늑대 정령",
		["Shadowform"] = "어둠의 형상",
	}
elseif locale == "zhTW" then
	L = {
		["Ghost Wolf"] = "幽魂之狼",
		["Shadowform"] = "暗影形態",
	}
end
L = setmetatable(L or {}, { __index = function(self, key) rawset(self, key, key) return key end })

Automaton_Flight = Automaton:NewModule("Flight", "AceEvent-2.0")
local module = Automaton_Flight

module.description = L["Automatically dismount or unshapeshift when speaking to flight masters"]
module.options = {}

function module:OnInitialize()
	self:RegisterOptions(self.options)
end

function module:OnEnable()
	self:RegisterEvent("TAXIMAP_OPENED")
end

local _, class = UnitClass("player")
function module:TAXIMAP_OPENED()
	if IsMounted() then
		Dismount()
	elseif class == "DRUID" then
		for i = 1,GetNumShapeshiftForms() do
			local _, name, active = GetShapeshiftFormInfo(i)
			if active then
				CancelPlayerBuff(name)
			end
		end
	elseif class == "SHAMAN" then
		CancelPlayerBuff(L["Ghost Wolf"])
	elseif class == "PRIEST" then
		CancelPlayerBuff(L["Shadowform"])
	end
end